SystemOrganization addCategory: #'SOUL-GrammarClauses'!

Object subclass: #HornClause
	instanceVariableNames: 'condition containsCut envSize comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-GrammarClauses'!

HornClause subclass: #ConcludableClause
	instanceVariableNames: 'conclusion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-GrammarClauses'!

!ConcludableClause class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
condition: aCondition conclusion: aConclusion
	
	^self new condition: aCondition conclusion: aConclusion! !

!ConcludableClause methodsFor: 'repository' stamp: 'sp 24/10/11 15:26'!
addToRepository: aRep
	
	| var |
	self conclusion isCallTerm
		ifTrue:
			[var := self conclusion variable.
			aRep
				addCallClause: self asNormalClause
				for: var]
		ifFalse: [aRep addNormalClause: self]! !

!ConcludableClause methodsFor: 'converting' stamp: 'sp 24/10/11 15:26'!
asNormalClause
	
	conclusion := self conclusion asNormalTerm! !

!ConcludableClause methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
conclusion
	
	^conclusion! !

!ConcludableClause methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
conclusion: aConclusion
	
	conclusion := aConclusion! !

!ConcludableClause methodsFor: 'initialize' stamp: 'sp 24/10/11 15:26'!
condition: aCondition conclusion: aConclusion
	
	super condition: aCondition.
	conclusion := aConclusion! !

!ConcludableClause methodsFor: 'scoping' stamp: 'sp 24/10/11 15:26'!
definitionRepository: aRepository
	
	self conclusion recursiveDefinitionRepository: aRepository.
	^super definitionRepository: aRepository! !

!ConcludableClause methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
isTabledRule
	
	^false! !

!ConcludableClause methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
multiplicity
	
	^conclusion multiplicity! !

!ConcludableClause methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
predicate
	
	^conclusion predicate! !

ConcludableClause subclass: #Fact
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-GrammarClauses'!

!Fact class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
conclusion: aTerm
	
	^self new conclusion: aTerm! !

!Fact methodsFor: 'visitor' stamp: 'sp 24/10/11 15:26'!
accept: aVisitor
	
	^aVisitor factVisit: self! !

!Fact methodsFor: 'initialize' stamp: 'AndyKellens 11/2/2011 09:53'!
conclusion: aTerm
	
	super
		condition:
			(SoulFactory current makeTermSequence
				terms: OrderedCollection new
				containsCut: false)
		conclusion: aTerm! !

!Fact methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
fixClean: fixVisitor
	
	conclusion accept: fixVisitor! !

!Fact methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
prettyPrintOn: aStream scope: id
	"see comment in AbstractClause"

	
	self prettyPrintCommentOn: aStream.
	conclusion prettyPrintOn: aStream scope: id! !

!Fact methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
printAsPrologOn: aStream
	"TODO: not correct if fact contains positive or negative variables"

	
	conclusion printAsPrologOn: aStream scope: #asClause in: nil startAt: nil.
	aStream
		write: '.';
		cr! !

!Fact methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
printForCompileOn: aStream
	"see comment in AbstractClause"

	
	aStream write: '(' , self class name , ' conclusion:( '.
	conclusion printForCompileOn: aStream.
	aStream write: '))'.
	self hasComment
		ifTrue:
			[aStream write: ' comment: ' , self comment storeString , '; yourself']! !

!Fact methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
printOn: aStream
	"see comment in AbstractClause"

	
	self printCommentOn: aStream.
	conclusion printOn: aStream! !

!Fact methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
usesPredicate: aPredicate multiplicity: aNumber
	
	^false! !

ConcludableClause subclass: #Rule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-GrammarClauses'!

Rule subclass: #DCGRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-GrammarClauses'!

!DCGRule methodsFor: 'initialize' stamp: 'sp 24/10/11 15:26'!
condition: aCondition conclusion: aConclusion
	
	containsCut := aCondition containsCut.
	condition := aCondition.
	conclusion := aConclusion.
	self convertToRule! !

!DCGRule methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
convertConclusion
	
	conclusion := conclusion asDCGConclusionWithSize: condition terms size + 1! !

!DCGRule methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
convertCondition
	
	| counter newTerms |
	counter := 1.
	newTerms := OrderedCollection new.
	condition terms
		do:
			[:aTerm | 
			newTerms add: (aTerm asDCGConditionFor: counter).
			counter := counter + 1].
	condition terms: newTerms! !

!DCGRule methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
convertToRule
	"Convert the DCG spec in this rule to a logic rule that is able to execute the parsing process:
		s(a,b) --> np(a),vp(b)   ==>>  s(a,b,L1,L3) if np(a,L1,L2),vp(b,L2,L3)"

	
	self convertConclusion.
	self convertCondition! !

!DCGRule methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
prettyPrintConclusionOn: aStream
	
	| subterms |
	conclusion functor prettyPrintAsFunctorOn: aStream scope: #asClause.
	subterms := conclusion termSequence terms.
	subterms size > 2
		ifTrue:
			[aStream write: '('.
			(1 to: subterms size - 2)
				do: [:i | (subterms at: i) prettyPrintOn: aStream scope: #asTerm]
				separatedBy: [aStream write: ','].
			aStream write: ')']! !

!DCGRule methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
prettyPrintCondition: aCondition on: aStream
	"DISCLAIMER: enjoy this wonderful method full of violations of the law of demeter and explicit type checks"

	"and is disallowed in the body of dcg rules for 'normal' users ... so it can only originate from the dcg translation of SymbiosisTerms"

	
	| terminals subterms |
	((aCondition isKindOf: CompoundTerm)
		and: [aCondition functor name == #and])
		ifTrue:
			[(aCondition termSequence terms at: 1) printOn: aStream.
			^self].
	((aCondition isKindOf: CompoundTerm)
		and: [aCondition functor name == #equals])
		ifTrue:
			[| temp |
			temp := aStream emphasis.
			aStream
				emphasis:
					(Array
						with: #color -> ColorValue purple
						with: #bold).
			aStream write: '<'.
			aStream emphasis: temp.
			terminals := OrderedCollection new.
			aCondition termSequence terms last
				listDo: [:aTerminal | terminals add: aTerminal].
			terminals
				do:
					[:aTerminal | 
					(aTerminal isKindOf: Variable)
						ifFalse: [aTerminal prettyPrintOn: aStream scope: #asTerm]]
				separatedBy: [aStream write: ','].
			aStream
				emphasis:
					(Array
						with: #color -> ColorValue purple
						with: #bold).
			aStream write: '>'.
			aStream emphasis: temp]
		ifFalse:
			[(aCondition isKindOf: CompoundTerm)
				ifTrue:
					[aCondition functor prettyPrintAsFunctorOn: aStream scope: #asClause.
					subterms := aCondition termSequence terms.
					subterms size > 2
						ifTrue:
							[aStream write: '('.
							(1 to: subterms size - 2)
								do: [:i | (subterms at: i) prettyPrintOn: aStream scope: #asClause]
								separatedBy: [aStream write: ','].
							aStream write: ')']]
				ifFalse: [aCondition printOn: aStream]]! !

!DCGRule methodsFor: 'printing' stamp: 'AndyKellens 11/4/2011 15:05'!
prettyPrintOn: aStream scope: id
	"see comment in AbstractClause"

	
	self prettyPrintCommentOn: aStream.
	self prettyPrintConclusionOn: aStream.
	aStream withAttributes:(Array with: TextEmphasis bold with:(TextColor red)) do:[
	aStream write: ' --> '].
	condition terms
		do: [:aCondition | self prettyPrintCondition: aCondition on: aStream]
		separatedBy: [aStream write: ',']! !

!DCGRule methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
printConclusionOn: aStream
	
	| subterms |
	conclusion functor printOn: aStream.
	subterms := conclusion termSequence terms.
	subterms size > 2
		ifTrue:
			[aStream write: '('.
			(1 to: subterms size - 2)
				do: [:i | (subterms at: i) printOn: aStream]
				separatedBy: [aStream write: ','].
			aStream write: ')']! !

!DCGRule methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
printCondition: aCondition on: aStream
	"DISCLAIMER: enjoy this wonderful method full of violations of the law of demeter and explicit type checks"

	"and is disallowed in the body of dcg rules for 'normal' users ... so it can only originate from the dcg translation of SymbiosisTerms"

	
	| terminals subterms |
	((aCondition isKindOf: CompoundTerm)
		and: [aCondition functor name == #and])
		ifTrue:
			[(aCondition termSequence terms at: 1) printOn: aStream.
			^self].
	((aCondition isKindOf: CompoundTerm)
		and: [aCondition functor name == #equals])
		ifTrue:
			[aStream write: '<'.
			terminals := OrderedCollection new.
			aCondition termSequence terms last
				listDo: [:aTerminal | terminals add: aTerminal].
			terminals
				do:
					[:aTerminal | (aTerminal isKindOf: Variable) ifFalse: [aTerminal printOn: aStream]]
				separatedBy: [aStream write: ','].
			aStream write: '>']
		ifFalse:
			[(aCondition isKindOf: CompoundTerm)
				ifTrue:
					[aCondition functor printOn: aStream.
					subterms := aCondition termSequence terms.
					subterms size > 2
						ifTrue:
							[aStream write: '('.
							(1 to: subterms size - 2)
								do: [:i | (subterms at: i) printOn: aStream]
								separatedBy: [aStream write: ','].
							aStream write: ')']]
				ifFalse: [aCondition printOn: aStream]]! !

!DCGRule methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
printOn: aStream
	
	self printCommentOn: aStream.
	self printConclusionOn: aStream.
	aStream write: ' --> '.
	condition terms
		do: [:aCondition | self printCondition: aCondition on: aStream]
		separatedBy: [aStream write: ',']! !

!Rule methodsFor: 'visitor' stamp: 'sp 24/10/11 15:26'!
accept: aVisitor
	
	^aVisitor ruleVisit: self! !

!Rule methodsFor: 'parsing' stamp: 'sp 24/10/11 15:26'!
addChildrenInitial: aCollection
	
	super
		condition: aCollection last
		conclusion: aCollection first! !

!Rule methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
allAfter: anObject in: aCollection
	
	| startIndex |
	startIndex := aCollection indexOf: anObject.
	^aCollection
		copyFrom: startIndex + 1
		to: aCollection size! !

!Rule methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
allBefore: anObject in: aCollection
	
	^aCollection copyUpTo: anObject! !

!Rule methodsFor: 'converting' stamp: 'sp 24/10/11 15:26'!
asTabledRuleWithConditionString: aString
	
	^TabledRule condition: condition conclusion: conclusion conditionString:
			aString! !

!Rule methodsFor: 'SLG' stamp: 'sp 24/10/11 15:26'!
bridgeContinuationRulesFor: aCallTerm withTabledRule: aTabledRule sequenceNr: anInteger remainingConditions: aTermCollection withContinuationString: aString withCallGraph: aCallGraph
	
	| tabledCall callTransformer splitIndex ownConditions contConditions rules vars beforeVarConditions slgcallString conditionVarString |
	callTransformer := self detectBridgeCallIn: aTermCollection
		withTabledRule: aTabledRule withCallGraph: aCallGraph.
	callTransformer isNil
		ifTrue:
			[^OrderedCollection
				with:
					(self bridgeEndRuleWith: anInteger callTerm: aCallTerm conditions:
							aTermCollection continuationString: aString)]
		ifFalse:
			[^self halt:
					'not yet implemented, why on earth do you call one rule twice :(']! !

!Rule methodsFor: 'SLG' stamp: 'sp 24/10/11 15:26'!
bridgeEndRuleWith: anInteger callTerm: resultTerm conditions: aTermCollection continuationString: aString vars: vars
	
	| conditionVarString |
	conditionVarString := '(?Id, vars asString,' , resultTerm asString ,
			', ?D, ?Cont)'.
	^self
		generateRule:
			self predicate , 'bridge' , anInteger asString , conditionVarString ,
					' if '
				,
					(aTermCollection isEmpty
						ifTrue: ['']
						ifFalse: [(TermSequence terms: aTermCollection) printString , ',']) ,
					aString
		onError: [:e :p | self halt]! !

!Rule methodsFor: 'SLG' stamp: 'sp 24/10/11 15:26'!
bridgeImplementationRulesFor: aTermCollection withTabledRule: aTabledRule withCallGraph: aCallGraph withContinuationString: aString
	"we differ from the paper here: the paper passes a continuation, which is already known at compile-time, so we just inline the continuation.
	The only problem that I see is when you have a tabled rule with 2 implementations (for example foo :- bar, baz and foo :- bar, meh), so we
	need to transform the bridge twice and dont pass the same continuation.
	why we do it like this is because it fits better in the whole approach/scheme/code we did for the 1st paper, and reimplementing it would cost me another
	month (and probably a trip straight to the psych)."

	
	| rules callTransformer bridgeCall conclusionString remainingConditions previousConditions ruleString previousConditionsString vars slgcallString |
	callTransformer := self detectBridgeCallIn: aTermCollection
		withTabledRule: aTabledRule withCallGraph: aCallGraph.
	conclusionString := self predicate , 'bridge' , '(?Id)'.
	callTransformer isNil
		ifTrue: [self halt: 'bridge predicate without a bridge Oo']
		ifFalse:
			[bridgeCall := callTransformer tabledCall.
			previousConditions := self allBefore: bridgeCall in: aTermCollection.
			remainingConditions := self allAfter: bridgeCall in: aTermCollection.
			vars := self
				environmentVariablesForCallTerm: bridgeCall
				inRuleWithConclusion: self conclusion
				termsBefore: previousConditions
				termsAfter: remainingConditions.
			rules := self bridgeContinuationRulesFor: bridgeCall withTabledRule:
					aTabledRule sequenceNr: 0 remainingConditions: remainingConditions
				withContinuationString: aString withCallGraph: aCallGraph.
			previousConditionsString := (TermSequence terms: previousConditions)
				printString.
			previousConditionsString = ''
				ifFalse: [previousConditionsString := previousConditionsString , ','].
			slgcallString := callTransformer transform: vars.
			ruleString := conclusionString , ' if ' , previousConditionsString ,
					slgcallString].
	rules
		addFirst:
			(self
				generateRule: ruleString
				onError: [:a :b | self error: 'Something went terribly wrong!!']).
	^rules! !

!Rule methodsFor: 'SLG' stamp: 'sp 24/10/11 15:26'!
detectBridgeCallIn: aTermCollection withTabledRule: aRule withCallGraph: aCallGraph
	
	aTermCollection
		detect:
			[:aTerm | 
			aTerm isCompoundTerm
				ifTrue:
					[aTerm functor asString = 'not'
						ifFalse:
							[(aCallGraph isTermConnected: aTerm withClause: aRule) isEmpty not]
						ifTrue: [false]]
				ifFalse: [false]]
		ifNone: [nil]! !

!Rule methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
environmentVariablesForCallTerm: aCallOfTabledPredicate inRuleWithConclusion: aConclusion termsBefore: beforeCollection termsAfter: afterCollection
	"taken from the paper: all variables in the head must be passed to the cont of Li
	in addition all vars that occur BOTH in L1..Li-1 and Li..Ln must be passed to cont Li
	aCallOfTabledPredicate is Li, aConclusion is the conclusion of the rule we are transforming"

	"TODO: should be possible to capture the actual environment instead (c) Coen"

	
	| left right lfree rfree varsintersected |
	left := OrderedCollection new.
	left addAll: beforeCollection.
	left add: aConclusion.
	lfree := self variableNamesIn: (TermSequence terms: left).
	right := OrderedCollection new.
	right addAll: afterCollection.
	right add: aConclusion.
	right add: aCallOfTabledPredicate.
	rfree := self variableNamesIn: (TermSequence terms: right).
	varsintersected := (lfree select: [:v | rfree includes: v])
		asOrderedCollection.
	^ListTerm
		newFromCollection:
			(varsintersected collect: [:name | Variable name: name])! !

!Rule methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
fixClean: fixVisitor
	
	conclusion accept: fixVisitor.
	condition do: [:each | each accept: fixVisitor]! !

!Rule methodsFor: 'private' stamp: 'AndyKellens 11/2/2011 09:53'!
generateRule: aString onError: aBlock
	
	| newRule |
	newRule := (SoulFactory current makeParser parse: aString onError: aBlock)
		clauses first.
	newRule recursiveDefinitionRepository: self definitionRepository.	"newRule condition definitionRepository: (self definitionRepository).
 	newRule conclusion definitionRepository: (self definitionRepository).
	newRule definitionRepository: (self definitionRepository)."

	^newRule! !

!Rule methodsFor: 'SLG' stamp: 'sp 24/10/11 15:26'!
isBridgeNeeded: aTabledRule withCallGraph: aCallGraph
	
	| bridgeCall allAfter terms |
	terms := self condition term terms.
	bridgeCall := self detectBridgeCallIn: terms withTabledRule: aTabledRule
		withCallGraph: aCallGraph.
	allAfter := self allAfter: bridgeCall in: terms.
	^allAfter isEmpty not! !

!Rule methodsFor: 'printing' stamp: 'AndyKellens 11/4/2011 15:01'!
prettyPrintOn: aStream scope: id
	
	self prettyPrintCommentOn: aStream.
	conclusion prettyPrintOn: aStream scope: id.
	aStream withAttributes:(Array with:(TextEmphasis bold) with: (TextColor color:(Color red))) do:[
	aStream
		write: ' if ';
		cr].
	condition prettyPrintOn: aStream scope: id! !

!Rule methodsFor: 'printing' stamp: 'AndyKellens 11/2/2011 09:53'!
printAsPrologOn: aStream
	
	| processedVariables |
	conclusion printAsPrologOn: aStream scope: #asClause in: nil startAt: nil.
	aStream
		write: ' :- ';
		crtab.	"UGLY: bweeeuuuk...."

	processedVariables := Set new.
	conclusion
		accept:
			(SoulFactory current makeNamedVariableVisitor
				doBlock:
					[:aVariable | 
					(aVariable isKindOf: PosVariable)
						& (processedVariables includes: aVariable) not
						ifTrue:
							[processedVariables add: aVariable.
							aStream write: 'nonvar('.
							aVariable printAsPrologOn: aStream scope: #asTerm in: nil startAt:
									nil.
							aStream
								write: '),';
								crtab].
					(aVariable isKindOf: NegVariable)
						& (processedVariables includes: aVariable) not
						ifTrue:
							[processedVariables add: aVariable.
							aStream write: 'var('.
							aVariable printAsPrologOn: aStream scope: #asTerm in: nil startAt:
									nil.
							aStream
								write: '),';
								crtab]]).
	condition printAsPrologOn: aStream scope: #asClause in: nil startAt: nil.
	aStream
		write: '.';
		cr! !

!Rule methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
printForCompileOn: aStream
	
	aStream write: '(' , self class name , ' condition: ('.
	condition printForCompileOn: aStream.
	aStream write: ') conclusion: ('.
	conclusion printForCompileOn: aStream.
	aStream write: '))'.
	self hasComment
		ifTrue:
			[aStream write: ' comment: ' , self comment storeString , '; yourself']! !

!Rule methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
printOn: aStream
	
	self printCommentOn: aStream.
	conclusion printOn: aStream.
	aStream
		write: ' if ';
		crtab.
	condition printOn: aStream! !

!Rule methodsFor: 'SLG' stamp: 'sp 24/10/11 15:26'!
transformBridge: aTabledRule withCallGraph: aCallGraph
	
	^self
		bridgeContinuationRules: self condition term
		withTabledRule: aTabledRule
		withCallGraph: aCallGraph! !

!Rule methodsFor: 'private' stamp: 'AndyKellens 11/2/2011 09:53'!
variableNamesIn: aTerm
	
	| variables variableVisitor |
	variables := OrderedCollection new.
	variableVisitor := SoulFactory current makeNamedVariableVisitor
		doBlock:
			[:var | 
			var isHiddenVariable
				ifFalse:
					[(variables includes: (var name asSymbol))
						ifFalse:[variables add: (var name asSymbol)]
						]].
	aTerm accept: variableVisitor.
	^variables! !

Rule subclass: #TabledRule
	instanceVariableNames: 'conditionString generatedRules'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-GrammarClauses'!

!TabledRule class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
condition: condition conclusion: conclusion conditionString: aString
	
	^(super condition: condition conclusion: conclusion) conditionString:
			aString! !

!TabledRule class methodsFor: 'converting' stamp: 'AndyKellens 11/3/2011 11:14'!
transformTabledRules: aCollection withCallGraph: aCallGraph
	
	| uniqueRules newRules key values |
	newRules := OrderedCollection new.
	uniqueRules := Dictionary new.
	aCollection
		do:
			[:aTabledRule | 
			key := aTabledRule conclusion functor asString.
			values := uniqueRules
				at: key
				ifAbsent: [OrderedCollection new].
			values
				detect: [:x | x conclusion isSLGEquivalentTo: aTabledRule conclusion]
				ifNone: [values add: aTabledRule].
			uniqueRules at: key put: values].
	uniqueRules
		do:
			[:rules | rules do: [:aTabledRule | newRules add: aTabledRule slgTransformMain]].
	aCollection
		do:
			[:aTabledRule | 
			newRules
				addAll:
					(aTabledRule slgTransformWith: aCollection withCallGraph: aCallGraph)].
	^newRules! !

!TabledRule methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
addGeneratedRule: aRule
	
	generatedRules add: aRule! !

!TabledRule methodsFor: 'repository' stamp: 'AndyKellens 10/28/2011 13:08'!
addToRepository: aRepository
	super addToRepository: aRepository.
	aRepository addTabledRule: self! !

!TabledRule methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
conditionString: aString
	
	conditionString := aString! !

!TabledRule methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
detectTabledCallIn: aTermCollection withTabledRules: aCollection withCallGraph: aCallGraph
	"Check if the conditions contain a call to a tabled predicate or bridge predicate
	aCollection is a collection of TabledRules.
	Returns a transformer, which can be called to get the transformation.
	Returns nil if no such rule is found"

	
	| names |
	names := aCollection
		collect:
			[:rule | rule conclusion functor printString , rule conclusion multiplicity asString].
	aTermCollection
		do:
			[:aCondition | 
			aCondition isCompoundTerm
				and:
					["either we have a direct call to a tabled call" 
					names
						do:
							[:name | 
							name = (aCondition functor printString , aCondition multiplicity asString)
								ifTrue:
									[^TabledRuleSLGCallTransformer with: aCondition fromRule: self].
							(self isTabledNotCall: aCondition withTabledName: name)
								ifTrue:
									[^TabledRuleSLGNotTransformer with: aCondition fromRule: self]]	"(self isBridgeCall: aCondition withCallGraph: aCallGraph) ifTrue:
					[ ^TabledRuleBridgeTransformer with: aCondition fromRule: self ]."
]].
	^nil! !

!TabledRule methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
generateContinuationHead: anInteger
	
	^'cont' , anInteger asString , self predicate reject: [:x | x = $:]! !

!TabledRule methodsFor: 'private' stamp: 'AndyKellens 11/2/2011 09:53'!
generateRule: aString onError: aBlock
	
	| newRule |
	newRule := (SoulFactory current makeParser parse: aString onError: aBlock)
		clauses first.
	newRule recursiveDefinitionRepository: self definitionRepository.	"newRule condition definitionRepository: (self definitionRepository).
 	newRule conclusion definitionRepository: (self definitionRepository).
	newRule definitionRepository: (self definitionRepository)."

	self generatedRules add: newRule.
	^newRule! !

!TabledRule methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
generateSLGConclusion
	
	| functor |
	functor := self conclusion functor.
	functor isMessageFunctor
		ifTrue:
			[| result terms |
			terms := self conclusion termSequence terms.
			result := '?Id id: ' , (terms at: 1) asString , ' slg'.
			functor keywords
				doWithIndex:
					[:keyword :i | result := result , keyword asString , ': ' , (terms at: i + 1) asString].
			^result]
		ifFalse:
			[^'slg' , functor asString , '(?Id,'
				, self conclusion termSequence asString , ')']! !

!TabledRule methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
generatedRules
	
	generatedRules ifNil: [generatedRules := OrderedCollection new].
	^generatedRules! !

!TabledRule methodsFor: 'accessing' stamp: 'sp 24/10/11 15:26'!
generatedRules: aCollection
	
	generatedRules := aCollection! !

!TabledRule methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
isBridgeCall: aTerm withCallGraph: aCallGraph
	"not calls are no bridges (I think), as not's can not generate bindings for variables
	as they are supposed to be ground"

	
	| connectedBy bridges |
	aTerm functor asString = 'not'
		ifFalse:
			[connectedBy := aCallGraph isTermConnected: aTerm withClause: self.
			bridges := connectedBy
				collect: [:term | term isBridgeNeeded: self withCallGraph: aCallGraph].
			^bridges isEmpty not]
		ifTrue: [^false]! !

!TabledRule methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
isTabledNotCall: aCondition withTabledName: aString
	"checks if aCondition is of the form not(aString) where aString is path(a,b)/2"

	"valiant knight, please prepare for horror and a princess in another castle"

	
	| theElement |
	aCondition functor printString = 'not' ifFalse: [^false].	"we restrict this to nots with only 1 term"
	"TODO: change this? watch out as we need to do variable passing and other nasty stuff"

	aCondition termSequence size = 1 ifFalse: [^false].
	theElement := aCondition termSequence terms first.
	^aString
		= (theElement functor asString , theElement multiplicity asString)! !

!TabledRule methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
isTabledRule
	
	^true! !

!TabledRule methodsFor: 'printing' stamp: 'AndyKellens 11/4/2011 15:06'!
prettyPrintOn: aStream scope: id
	
	self prettyPrintCommentOn: aStream.
	aStream withAttributes:(Array with: TextEmphasis italic with:(TextColor gray)) do:[
		aStream write: 'tabled '.
		super prettyPrintOn: aStream scope: id]! !

!TabledRule methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
printForCompileOn: aStream
	
	aStream write: '(' , self class name , ' condition: ('.
	condition printForCompileOn: aStream.
	aStream write: ') conclusion: ('.
	conclusion printForCompileOn: aStream.
	aStream write: ') conditionString: ('.
	conditionString printOn: aStream.
	aStream nextPutAll: '))'.
	self hasComment
		ifTrue:
			[aStream write: ' comment: ' , self comment storeString , '; yourself']! !

!TabledRule methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
printOn: aStream
	
	self printCommentOn: aStream.
	aStream write: 'tabled '.
	conclusion printOn: aStream.
	aStream
		write: ' if ';
		crtab.
	aStream nextPutAll: conditionString! !

!TabledRule methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
slgAnswerRuleWith: anInteger callTerm: resultTerm conditions: aTermCollection environmentVariables: vars
	
	| answer conditionVarString |
	conditionVarString := resultTerm functor asString = 'not'
		ifTrue: ['(?Id,' , vars asString , ',?D)']
		ifFalse: ['(?Id,' , vars asString , ',' , resultTerm asString , ',?D)'].
	answer := self conclusion.
	^self
		generateRule:
			(self generateContinuationHead: anInteger) , conditionVarString , ' if '
				,
					(aTermCollection isEmpty
						ifTrue: ['']
						ifFalse: [(TermSequence terms: aTermCollection) printString , ',']) ,
					'answer(?Id,' , answer asString , ',?D)'
		onError: [:e :p | self halt]! !

!TabledRule methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
slgContinuationRulesFor: aCallTerm withTabledRules: aCollection sequenceNr: anInteger remainingConditions: aTermCollection endVars: endVars withCallGraph: aCallGraph
	
	| tabledCall callTransformer splitIndex ownConditions contConditions rules vars beforeVarConditions slgcallString conditionVarString |
	callTransformer := self detectTabledCallIn: aTermCollection
		withTabledRules: aCollection withCallGraph: aCallGraph.
	callTransformer isNil
		ifTrue:
			[^OrderedCollection
				with:
					(self slgAnswerRuleWith: anInteger callTerm: aCallTerm conditions:
							aTermCollection environmentVariables: endVars)]
		ifFalse:
			[tabledCall := callTransformer tabledCall.
			splitIndex := aTermCollection indexOf: tabledCall.
			ownConditions := splitIndex = 1
				ifTrue: [ownConditions := OrderedCollection new]
				ifFalse: [aTermCollection copyUpTo: splitIndex - 1].	"we need all the vars from L1 - Li-1, meaning we cant use remainingConditions as that only contains Lj - Ln, where Lj-1 is last tabled call"

			beforeVarConditions := self
				allBefore: aCallTerm
				in: condition terms.
			beforeVarConditions add: aCallTerm.
			contConditions := aTermCollection
				copyFrom: splitIndex + 1
				to: aTermCollection size.
			vars := self
				environmentVariablesForCallTerm: tabledCall
				inRuleWithConclusion: self conclusion
				termsBefore: beforeVarConditions
				termsAfter: contConditions.
			rules := self
				slgContinuationRulesFor: tabledCall
				withTabledRules: aCollection
				sequenceNr: anInteger + 1
				remainingConditions: contConditions
				endVars: vars copy
				withCallGraph: aCallGraph.
			slgcallString := callTransformer
				transform: vars
				withInteger: anInteger + 1.
			conditionVarString := '(?Id,' , endVars asString , ','
				, aCallTerm asString , ',?D)'.
			rules
				addFirst:
					(self
						generateRule:
							(self generateContinuationHead: anInteger) , conditionVarString , 'if '
								, (TermSequence terms: ownConditions) printString
								,
									(ownConditions isEmpty
										ifTrue: ['']
										ifFalse: [',']) , slgcallString
						onError: [:e | self halt]).
			^rules]! !

!TabledRule methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
slgImplementationRulesFor: aTermCollection withTabledRules: aCollection withCallGraph: aCallGraph
	
	| rules callTransformer tabledCall conclusionString remainingConditions previousConditions ruleString previousConditionsString vars slgcallString |
	conclusionString := self generateSLGConclusion.
	callTransformer := self detectTabledCallIn: aTermCollection
		withTabledRules: aCollection withCallGraph: aCallGraph.
	callTransformer isNil
		ifTrue:
			[ruleString := conclusionString , ' if ' , self condition printString ,
					', answer(?Id, ' , self conclusion printString ,
					',[ Array with: (OrderedCollection new) with: (OrderedCollection new) ])'.
			rules := OrderedCollection new]
		ifFalse:
			[tabledCall := callTransformer tabledCall.
			previousConditions := self allBefore: tabledCall in: aTermCollection.
			remainingConditions := self allAfter: tabledCall in: aTermCollection.
			vars := self
				environmentVariablesForCallTerm: tabledCall
				inRuleWithConclusion: self conclusion
				termsBefore: previousConditions
				termsAfter: remainingConditions.
			rules := self slgContinuationRulesFor: tabledCall withTabledRules:
					aCollection sequenceNr: 0 remainingConditions: remainingConditions
				endVars: vars withCallGraph: aCallGraph.
			previousConditionsString := (TermSequence terms: previousConditions)
				printString.
			previousConditionsString = ''
				ifFalse: [previousConditionsString := previousConditionsString , ','].
			slgcallString := callTransformer transform: vars.
			ruleString := conclusionString , ' if ' , previousConditionsString ,
					slgcallString].
	rules
		addFirst:
			(self
				generateRule: ruleString
				onError: [:a :b | self error: 'Something went terribly wrong!!']).
	^rules! !

!TabledRule methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
slgTransformMain
	
	| literal newRule |
	literal := self conclusion printString.
	newRule := self
		generateRule: literal , ' if  slg(' , literal , ')'
		onError: [:a :b | self error: 'Something went terribly wrong!!'].
	^newRule! !

!TabledRule methodsFor: 'converting' stamp: 'sp 24/10/11 15:26'!
slgTransformWith: aTabledRuleCollection withCallGraph: aCallGraph
	
	| newRules |
	self generatedRules: OrderedCollection new.
	newRules := self
		slgImplementationRulesFor: self condition terms
		withTabledRules: aTabledRuleCollection
		withCallGraph: aCallGraph.
	self generatedRules addAll: newRules.
	^newRules! !

!HornClause class methodsFor: 'signal constants' stamp: 'sp 24/10/11 15:26'!
errorSignal
	
	^SoulError! !

!HornClause methodsFor: 'visitor' stamp: 'sp 24/10/11 15:26'!
accept: aVisitor
	
	self subclassResponsibility! !

!HornClause methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
additionalClausesForDefinitionRepository
	
	| clauses |
	clauses := OrderedCollection new.
	condition terms
		do:
			[:term | 
			term additionalClausesForDefinitionRepository
				ifNotNil: [:c | clauses addAll: c]].
	^clauses! !

!HornClause methodsFor: 'printing' stamp: 'AndyKellens 11/4/2011 15:00'!
asPrettyString
	
	| aStream |
	aStream := TextStream on: Text new.
	self prettyPrintOn: aStream scope: #asClause.
	^aStream contents! !

!HornClause methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
asProlog
	
	| stream |
	stream := WriteStream on: String new.
	self printAsPrologOn: stream.
	^stream contents! !

!HornClause methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
comment
	
	^comment ifNil: ['']! !

!HornClause methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
comment: aComment
	"Empty comments are stored as nil, saves us from having to store an empty string object"

	
	comment := aComment = ''
		ifTrue: [nil]
		ifFalse: [aComment]! !

!HornClause methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
condition
	
	^condition! !

!HornClause methodsFor: 'initialize' stamp: 'AndyKellens 10/28/2011 17:02'!
condition: aCondition
	
	condition := aCondition.
	containsCut := aCondition containsCut ! !

!HornClause methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
containsCut
	
	^containsCut! !

!HornClause methodsFor: 'scoping' stamp: 'sp 24/10/11 15:26'!
definitionRepository
	
	^self condition definitionRepository! !

!HornClause methodsFor: 'scoping' stamp: 'sp 24/10/11 15:26'!
definitionRepository: aRepository
	
	self condition recursiveDefinitionRepository: aRepository! !

!HornClause methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
envSize
	
	^envSize! !

!HornClause methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
fixClean: fixVisitor
	
	self subclassResponsibility! !

!HornClause methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
hasComment
	
	^comment isNil not! !

!HornClause methodsFor: 'testing' stamp: 'sp 24/10/11 15:26'!
isNative
	
	^false! !

!HornClause methodsFor: 'resolving' stamp: 'sp 24/10/11 15:26'!
makeClean
	"produce a clean copy of this clause (variables having a proper memory 
	location) "

	
	| fixer |
	fixer := FixVisitor new.
	self fixClean: fixer.
	self setEnvSize: fixer maxIndex + 1! !

!HornClause methodsFor: 'printing' stamp: 'AndyKellens 11/4/2011 14:58'!
prettyPrintCommentOn: aStream
	
	| temp |
	aStream withAttribute:(TextColor gray) do:[
	self printCommentOn: aStream]! !

!HornClause methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
prettyPrintOn: aStream scope: id
	
	self printOn: aStream! !

!HornClause methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
printAsPrologOn: aStream
	
	self subclassResponsibility! !

!HornClause methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
printCommentOn: aStream
	
	self hasComment
		ifTrue:
			[aStream
				nextPutAll: '"' , (comment copyReplaceAll: '"' with: '""') , '"';
				cr;
				cr]! !

!HornClause methodsFor: 'scoping' stamp: 'sp 24/10/11 15:26'!
recursiveDefinitionRepository: aRepository
	
	self definitionRepository: aRepository! !

!HornClause methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
setEnvSize: anInteger
	
	envSize := anInteger! !

!HornClause methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
usesPredicate: aPredicate multiplicity: aNumber
	
	self condition
		do:
			[:term | (term usesPredicate: aPredicate multiplicity: aNumber) ifTrue: [^true]].
	^false! !

HornClause subclass: #Query
	instanceVariableNames: 'variables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-GrammarClauses'!

!Query class methodsFor: 'instance creation' stamp: 'sp 24/10/11 15:26'!
condition: aQuery
	
	^self new condition: aQuery! !

!Query methodsFor: 'visitor' stamp: 'sp 24/10/11 15:26'!
accept: aVisitor
	
	^aVisitor queryVisit: self! !

!Query methodsFor: 'parsing' stamp: 'sp 24/10/11 15:26'!
addChildrenInitial: aCollection
	
	super condition: aCollection first! !

!Query methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
addConditionsInFront: aCollection
	
	condition terms: aCollection , condition terms! !

!Query methodsFor: 'private' stamp: 'AndyKellens 11/2/2011 09:53'!
fetchVariables
	
	| dict variableVisitor |
	dict := Dictionary new.
	variableVisitor := SoulFactory current makeNamedVariableVisitor
		doBlock:
			[:var | 
			dict
				at: var name
				ifAbsentPut: [var]].
	condition accept: variableVisitor.
	^dict asOrderedCollection! !

!Query methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
fixClean: fixVisitor
	
	condition do: [:each | each accept: fixVisitor]! !

!Query methodsFor: 'printing' stamp: 'AndyKellens 11/4/2011 15:04'!
prettyPrintOn: aStream scope: id
	
	| temp |
	self prettyPrintCommentOn: aStream.
	aStream withAttributes:(Array with:(TextColor red) with:(TextEmphasis bold)) do: [	aStream write: 'if '].
	condition prettyPrintOn: aStream scope: id! !

!Query methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
printForCompileOn: aStream
	
	aStream write: self class name , ' condition: ('.
	condition printForCompileOn: aStream.
	aStream write: ')'! !

!Query methodsFor: 'printing' stamp: 'sp 24/10/11 15:26'!
printOn: aStream
	
	aStream write: ' if '.
	super condition printOn: aStream! !

!Query methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
variableNamed: aString
	
	^self variables
		detect: [:each | each name = aString]
		ifNone:
			[self
				error:
					'Variable ''?' , aString , ''' not found in query: ''' , self printString ,
							'''']! !

!Query methodsFor: 'access' stamp: 'sp 24/10/11 15:26'!
variables
	
	variables
		ifNil:
			[variables := self fetchVariables.
			^variables].
	^variables! !

!Query methodsFor: 'private' stamp: 'sp 24/10/11 15:26'!
variables: vars
	
	variables := vars! !

Object subclass: #TabledRuleTransformer
	instanceVariableNames: 'tabledCall tabledRule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-GrammarClauses'!

TabledRuleTransformer subclass: #TabledRuleBridgeTransformer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-GrammarClauses'!

!TabledRuleBridgeTransformer methodsFor: 'converting' stamp: 'sp 24/10/11 15:26'!
transform: vars withInteger: anInteger
	"^'slgcall(?Id', vars asString, ','
			 ,tabledCall printString,  ',[ OrderedCollection with: (OrderedCollection new) with: (OrderedCollection new) ],' 
			, tabledRule predicate asString, 'cont', anInteger asString, ')'."

	
	^self halt: 'bridge predicate detected'! !

TabledRuleTransformer subclass: #TabledRuleSLGCallTransformer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-GrammarClauses'!

!TabledRuleSLGCallTransformer methodsFor: 'accessing' stamp: 'AndyKellens 10/28/2011 11:35'!
transform: vars withInteger: anInteger
	
	| slgcallString |
	slgcallString := 'slgcall' , '(?Id, ' , vars asString , ','
		, tabledCall printString ,
			',[ Array with: (OrderedCollection new) with: (OrderedCollection new) ],'
		, 'cont' , anInteger asString
		, (tabledRule predicate asString reject: [:x | x = $:]) , ')'.
	^slgcallString! !

TabledRuleTransformer subclass: #TabledRuleSLGNotTransformer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-GrammarClauses'!

!TabledRuleSLGNotTransformer methodsFor: 'converting' stamp: 'sp 24/10/11 15:26'!
transform: vars withInteger: anInteger
	
	^'slgnot' , '(?Id, ' , vars asString , ','
		, tabledCall termSequence asString ,
			',[ Array with: (OrderedCollection new) with: (OrderedCollection new) ],'
		, 'cont' , anInteger asString , tabledRule predicate asString , ')'! !

!TabledRuleTransformer class methodsFor: 'As yet unclassified' stamp: 'sp 24/10/11 15:26'!
with: aCondition fromRule: aTabledRule
	
	^self new with: aCondition fromRule: aTabledRule! !

!TabledRuleTransformer methodsFor: 'initialize-release' stamp: 'sp 24/10/11 15:26'!
tabledCall
	
	^tabledCall! !

!TabledRuleTransformer methodsFor: 'converting' stamp: 'sp 24/10/11 15:26'!
transform: vars
	
	^self transform: vars withInteger: 0! !

!TabledRuleTransformer methodsFor: 'converting' stamp: 'sp 24/10/11 15:26'!
transform: vars withInteger: anInteger
	
	^self subclassResponsibility! !

!TabledRuleTransformer methodsFor: 'initialize-release' stamp: 'sp 24/10/11 15:26'!
with: aTerm fromRule: aTabledRule
	
	tabledCall := aTerm.
	tabledRule := aTabledRule! !
